#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k, x, t1, q, p, t2;
    cin>>n>>k>>x;
    p = (n-1)*(n-2)/2;
    q = (n-x)*(n-x+1)/2;
    if(k < q)
    {
        cout<<-1;
    }
    else if(k >= p)
    {
        t1 = (n*(n-1))/2 - k;
        for(int i = n-1; i >= 0; i --)
        {
            cout<<i*x+1-t1<<" ";
            if(t1>0)
                t1--;
        }
    }
    else
    {
        t2 = k-q-1;
        for(int i = n; i > 0; i --)
        {
            cout<<i+t2<<" ";
             if(t2>0)
                t2--;
        }
    }
    return 0;
}